/************************************************************************  
*   PROGRAMA DE INICIAO CIENTFICA PIBIC/CNPq                         *
*   PROJETO: Desenvolvimento de um simulador de algoritmos qunticos    *
*            utilizando a computao convencional                       *
* --------------------------------------------------------------------- *
*      Bolsista: Anderson de Rezende Rocha - DCC/UFLA                   *
*                   # undersun@comp.ufla.br         (1)                 *
*                   # phiberoptic_br@yahoo.com.br   (2)                 *
* --------------------------------------------------------------------- *
*  Orientadores: Antnio Maria Pereira de Resende                       *
*                   # tonio@comp.ufla.br                                *
*                Antonio Tavares Costa Junior                           *
*                   # antc@stout.ufla.br                                *
*************************************************************************/

import java.util.Vector;
import java.io.*;

public class Fourier extends Operacoes implements Runnable
{
	private boolean flag;
	protected Registradores	reg;
	// Nmero de estados necessrios ao clculo 
    // no registrador
    protected int q;
	protected int size;
	
	public Fourier(Complexos seq[])
	{
		////////////// MUDANCAS //////////////
        if (testarPotenciaDois(seq.length))
            System.out.println(seq.length + " eh uma pot de 2");
        else
            System.out.println(seq.length + " NAO eh uma pot de 2");
        
        reg = new Registradores(seq.length);
		reg.setSequencia(seq);
        

        ////////////// MUDANCAS //////////////
        
        
        size = seq.length;
        q = seq.length;
//		q = (int)Math.pow(2, size);
		ALGORITMO = FOURIER;
	}

	private boolean executarAlgoritmo()
	{
		transformacaoFourier(reg, q);
		return true;
	}

    public Complexos[] getResultados()
    {
        try
        {
			return reg.getEstados();
        }
        catch (Exception ex) {return null;}
    }

	
	public void run()
	{
		if (!flag)
			if (executarAlgoritmo())
			{
				flag = true;
				FourierTask.setStatus(100);
			}
	}
}

